1
0
Fork 0
mirror of git://slackware.nl/current.git synced 2025-01-29 08:36:40 +01:00
slackware-current/source/x/fontconfig/fontconfig.SlackBuild
Patrick J Volkerding 4ccd8ebc9a Wed Sep 12 21:19:38 UTC 2018
a/elilo-3.16-x86_64-8.txz:  Rebuilt.
  eliloconfig: this was occasionally failing and the issue was traced to the
  script's use of tr (not sure why still). Replaced the construct with sed
  and the issue seems to have gone away.
a/openssl-solibs-1.1.1-x86_64-1.txz:  Upgraded.
d/binutils-2.31.1-x86_64-3.txz:  Rebuilt.
  Do not install the Windows-specific tools. Not only are these useless on
  Linux, but the presence of windres fools freetype into thinking that it is
  on a Windows system, leading to a build failure.
d/git-2.19.0-x86_64-1.txz:  Upgraded.
l/freetype-2.9.1-x86_64-1.txz:  Upgraded.
l/harfbuzz-1.9.0-x86_64-1.txz:  Upgraded.
l/media-player-info-24-noarch-1.txz:  Upgraded.
l/pcre2-10.32-x86_64-1.txz:  Upgraded.
l/sg3_utils-1.43-x86_64-1.txz:  Upgraded.
n/openssl-1.1.1-x86_64-1.txz:  Upgraded.
x/fontconfig-2.13.1-x86_64-1.txz:  Upgraded.
  We had problem reports with fontconfig-2.13.0 which led to it being reverted
  but we'll try it again. Please let me know if the issues (with Wine iirc)
  persist.
x/libinput-1.12.0-x86_64-1.txz:  Upgraded.
2018-09-13 09:00:32 +02:00

199 lines
6.4 KiB
Bash
Executable file

#!/bin/bash
# Copyright 2008, 2009, 2010, 2013, 2017, 2018 Patrick J. Volkerding, Sebeka, Minnesota, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
cd $(dirname $0) ; CWD=$(pwd)
PKGNAM=fontconfig
VERSION=${VERSION:-$(echo fontconfig-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
BUILD=${BUILD:-1}
# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
i?86) export ARCH=i586 ;;
arm*) export ARCH=arm ;;
# Unless $ARCH is already set, use uname -m for all other archs:
*) export ARCH=$( uname -m ) ;;
esac
fi
# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
# the name of the created package would be, and then exit. This information
# could be useful to other scripts.
if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
exit 0
fi
NUMJOBS=${NUMJOBS:-" -j7 "}
TMP=${TMP:-/tmp}
PKG=$TMP/package-fontconfig
if [ "$ARCH" = "i586" ]; then
SLKCFLAGS="-O2 -march=i586 -mtune=i686"
LIBDIRSUFFIX=""
elif [ "$ARCH" = "s390" ]; then
SLKCFLAGS="-O2"
LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
SLKCFLAGS="-O2 -fPIC"
LIBDIRSUFFIX="64"
else
SLKCFLAGS="-O2"
LIBDIRSUFFIX=""
fi
rm -rf $PKG
mkdir -p $TMP $PKG
cd $TMP
rm -rf fontconfig-$VERSION
tar xvf $CWD/fontconfig-$VERSION.tar.?z* || exit 1
cd fontconfig-$VERSION || exit 1
chown -R root:root .
find . \
\( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
-exec chmod 755 {} \; -o \
\( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
-exec chmod 644 {} \;
# Prefer DejaVu fonts in 60-latin.conf:
#zcat $CWD/fontconfig.dejavu.diff.gz | patch -p1 --verbose || exit 1
# Prefer Liberation fonts in 60-latin.conf (these work better with hinting):
zcat $CWD/fontconfig.liberation.diff.gz | patch -p1 --verbose || exit 1
# Hardcode the default font search path rather than having fontconfig figure
# it out (and possibly follow symlinks, or index ugly bitmapped fonts):
zcat $CWD/fontconfig.font.dir.list.diff.gz | patch -p1 --verbose --backup --suffix=.orig || exit 1
CFLAGS=$SLKCFLAGS \
./configure \
--prefix=/usr \
--libdir=/usr/lib${LIBDIRSUFFIX} \
--mandir=/usr/man \
--sysconfdir=/etc \
--with-templatedir=/etc/fonts/conf.avail \
--with-baseconfigdir=/etc/fonts \
--with-configdir=/etc/fonts/conf.d \
--with-xmldir=/etc/fonts \
--localstatedir=/var \
--enable-static=no \
--build=$ARCH-slackware-linux || exit 1
make $NUMJOBS || make || exit 1
make install DESTDIR=$PKG || exit 1
# Don't ship .la files:
rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
# Upstream has changed the default templatedir to /usr/share/fontconfig/conf.avail.
# This change, if accepted, would break any existing font package containing a
# conf.avail directory. The safest thing to do is to keep things in the
# traditional location, but put a link in the new place so that font packages
# following the new standard location will work. Let's hear it for being
# "more correct" at the expense of having things "just work"!
mkdir -p $PKG/usr/share/fontconfig
( cd $PKG/usr/share/fontconfig ; ln -sf /etc/fonts/conf.avail . )
mkdir -p $PKG/usr/doc/fontconfig-$VERSION
cp -a \
AUTHORS COPYING* INSTALL NEWS README \
$PKG/usr/doc/fontconfig-$VERSION
# You can shop for this kind of stuff in the source tarball.
rm -rf $PKG/usr/share/doc
rmdir $PKG/usr/share 2>/dev/null
# If there's a ChangeLog, installing at least part of the recent history
# is useful, but don't let it get totally out of control:
if [ -r ChangeLog ]; then
DOCSDIR=$(echo $PKG/usr/doc/*-$VERSION)
cat ChangeLog | head -n 1000 > $DOCSDIR/ChangeLog
touch -r ChangeLog $DOCSDIR/ChangeLog
fi
mkdir -p $PKG/var/log/setup
cat $CWD/setup.05.fontconfig > $PKG/var/log/setup/setup.05.fontconfig
chmod 755 $PKG/var/log/setup/setup.05.fontconfig
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
| cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
# Set up the default options in /etc/fonts/conf.d:
( cd $PKG/etc/fonts/conf.d
for fontconf in \
20-unhint-small-vera.conf \
30-metric-aliases.conf \
40-nonlatin.conf \
45-latin.conf \
49-sansserif.conf \
50-user.conf \
51-local.conf \
60-latin.conf \
65-fonts-persian.conf \
65-nonlatin.conf \
69-unifont.conf \
80-delicious.conf \
90-synthetic.conf ; do
if [ -r ../conf.avail/$fontconf ]; then
ln -sf ../conf.avail/$fontconf .
else
echo "ERROR: unable to symlink ../conf.avail/$fontconf, file does not exist."
exit 1
fi
done
if [ ! $? = 0 ]; then
exit 1
fi
)
if [ ! $? = 0 ]; then
echo "Missing /etc/fonts/$fontconf default. Exiting"
exit 1
fi
# This is a really ugly default. If you like it, you'll have to link this
# one yourself:
rm -f $PKG/etc/fonts/conf.d/10-hinting-slight.conf
# Fix manpages:
if [ -d $PKG/usr/man ]; then
( cd $PKG/usr/man
for manpagedir in $(find . -type d -name "man*") ; do
( cd $manpagedir
for eachpage in $( find . -type l -maxdepth 1) ; do
ln -s $( readlink $eachpage ).gz $eachpage.gz
rm $eachpage
done
gzip -9 *.?
)
done
)
fi
mkdir $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
zcat $CWD/doinst.sh.gz > $PKG/install/doinst.sh
cd $PKG
/sbin/makepkg -l y -c n --prepend $TMP/fontconfig-$VERSION-$ARCH-$BUILD.txz